#include "sys.h"
#include "stm32f1xx_hal.h"
#include "pwm.h"
#include "gpio.h"
#include "delayus.h"
#include "direction.h"
#include "avoid.h"
#include "track.h"
#include "remote.h"
/* չ ------------------------------------------------------------------*/
/* ˽кԭ --------------------------------------------------------------*/
/*  --------------------------------------------------------------------*/
/**
  * : ϵͳʱ
  * : 
  *   ֵ: 
  * ˵    : 
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct;
  RCC_ClkInitTypeDef RCC_ClkInitStruct;

  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;  // ⲿ8MHz
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;  // 9Ƶõ72MHzʱ
  HAL_RCC_OscConfig(&RCC_OscInitStruct);

  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;       // ϵͳʱӣ72MHz
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;              // AHBʱӣ72MHz
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;               // APB1ʱӣ36MHz
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;               // APB2ʱӣ72MHz
  HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2);

 	// HAL_RCC_GetHCLKFreq()/1000    1msжһ
	// HAL_RCC_GetHCLKFreq()/100000	 10usжһ
	// HAL_RCC_GetHCLKFreq()/1000000 1usжһ
  HAL_SYSTICK_Config(HAL_RCC_GetHCLKFreq()/1000);  // òϵͳδʱ
  /* ϵͳδʱʱԴ */
  HAL_SYSTICK_CLKSourceConfig(SYSTICK_CLKSOURCE_HCLK);
  /* ϵͳδʱжȼ */
  HAL_NVIC_SetPriority(SysTick_IRQn, 0, 0);
}


/**
  * : .
  * : 
  *   ֵ: 
  * ˵    : 
  */
int main(void)
{
  Remote_Init();			//ճʼ	
	/* λ裬ʼFlashӿںϵͳδʱ */
  HAL_Init();
  /* ϵͳʱ */
  SystemClock_Config();
	
/**************GPIO******************************************************************/
	GPIOA_Init();//ʼL298Nӿ
	GPIOB_Init();//ʼѰͺģӿ
//	GPIOC_Init()

/***************PWM******************************************************************/	
	 /* ͨöʱʼPWM */
  GENERAL_TIMx_Init();
  
  /* ͨPWM */
  HAL_TIM_PWM_Start(&htimx,TIM_CHANNEL_1);
  HAL_TIM_PWM_Start(&htimx,TIM_CHANNEL_2);
	TIM3->CCR1=TIM3->CCR2=400;//٣Χ0~1000ֵԽٶԽ
	
/* ѭ */
  while (1)
  {	
		
		key=Remote_Scan();	
		if(key)
		{	 
			switch(key)
			{
					    
				case 152:str="2";
		{
			forward();
		}break;
		case 48:str="4";
		{
			left();
		}break;
		case 122:str="6";
		{
			right();
		}break;
		case 56:str="8";
		{
			back();
		}break;
		default :break;	 
			}
			
		}else delay_ms(10);	  
		
		
		//Track();//Ѱ
	}

}



//..\Inc\bsp\SYSTEM\sys\stm32f10x.h(8297): error:  #5: cannot open source input file "stm32f10x_conf.h": No such file or directory
    #include "stm32f10x_conf.h"
